;; -*- package: ccl -*-
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; NotInROM.Lisp
;;
;; Copyright  1991 Northwestern University Institute for the Learning Sciences
;; All Rights Reserved
;;
;; author: Michael S. Engber
;;
;; Provides Not in ROM Routines
;; requiring this file loads in all currently implemented Not in ROM routines
;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Modification History
;;
;; 02/21/92 bill pathname to provide to avoid *module-search-path* hacking.
;;                Remove reference to "oou" logical host.
;;               :defaults nil for make-pathname.
;;               (provide :NotInROM)
;;

(in-package :ccl)

(eval-when (:compile-toplevel :load-toplevel :execute)
  (require :NotInROM-u (make-pathname :name      "NotInROM-u"
                                      :host      (pathname-host *loading-file-source-file*)
                                      :directory (pathname-directory *loading-file-source-file*)
                                      :defaults  nil)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(dolist (file (directory (merge-pathnames "+*.lisp" *loading-file-source-file*)))
  (load (make-pathname :name      (pathname-name file)
                       :directory (pathname-directory file)
                       :defaults  nil)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(provide :NotInROM)
